Package jebl.evolution.trees

# Class CompactRootedTree

java.lang.Object
jebl.evolution.trees.CompactRootedTree

All Implemented Interfaces:
  `Graph`, `RootedTree`, `Tree`, `Attributable`

public class CompactRootedTree extends Object implements RootedTree
A memory efficient rooted tree. - Uses a compact representation for the tree structure based primarily on indices instead of pointers and objects - Minimize penalty for unused features. Trees not using attributes or edges do not require additional per node/edge memory. Limitations: - Maximun of 2^16 nodes and 2^15 external nodes. This should not be a problem with the current sizes of phlogenetic trees we currently handle. - Some of the accessors are slower, typically the ones getting all nodes, all edges, all internal nodes etc. Traversing the tree and handling attributes speed should be fine (compared to SimpkeRootedTree)

Version:
  $Id: CompactRootedTree.java 935 2008-07-22 16:52:04Z rambaut $
Author:
  Joseph Heled

## Nested Class Summary

## Nested classes/interfaces inherited from interface jebl.util.Attributable

`Attributable.Utils`

## Nested classes/interfaces inherited from interface jebl.evolution.graphs.Graph

`Graph.NoEdgeException, Graph.Utils`

## Constructor Summary

Constructors
Constructor
Description
`CompactRootedTree(RootedTree t)`
Do all the hard work.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`conceptuallyUnrooted()`
Due to current implementation limitations, trees store "branch" information in nodes.
`List<Node>`
`getAdjacencies(Node node)`
Returns a list of nodes connected to this node by an edge
`Object`
`getAttribute(String name)`
`Map<String,Object>`
`getAttributeMap()`
Gets the entire attribute map.
`Set<String>`
`getAttributeNames()`
`List<Node>`
`getChildren(Node node)`
`Edge`
`getEdge(Node node1, Node node2)`
Returns the Edge that connects these two nodes
`double`
`getEdgeLength(Node node1, Node node2)`
Returns the length of the edge that connects these two nodes
`Set<Edge>`
`getEdges()`
`List<Edge>`
`getEdges(Node node)`
Returns a list of edges connected to this node
`Set<Edge>`
`getExternalEdges()`
`int`
`getExternalNodeCount(Node node)`
`Set<Node>`
`getExternalNodes()`
`List<Node>`
`getExternalNodes(Node node)`
`double`
`getHeight(Node node)`
`Set<Edge>`
`getInternalEdges()`
`Set<Node>`
`getInternalNodes()`
`double`
`getLength(Node node)`
`Node`
`getNode(Taxon taxon)`
`Set<Node>`
`getNodes()`
`Set<Node>`
`getNodes(int degree)`
`Node[]`
`getNodes(Edge edge)`
Returns an array of 2 nodes which are the nodes at either end of the edge.
`Node`
`getParent(Node node)`
`Edge`
`getParentEdge(Node node)`
`Node`
`getRootNode()`
The root of the tree has the largest node height of all nodes in the tree.
`Set<Taxon>`
`getTaxa()`
`Taxon`
`getTaxon(Node node)`
`boolean`
`hasHeights()`
`boolean`
`hasLengths()`
`boolean`
`isExternal(Node node)`
`boolean`
`isHeightsKnown()`
`boolean`
`isLengthsKnown()`
`boolean`
`isRoot(Node node)`
`void`
`removeAttribute(String name)`
`void`
`renameTaxa(Taxon from, Taxon to)`
`void`
`setAttribute(String name, Object value)`
Sets an named attribute for this object.
`void`
`setConceptuallyUnrooted(boolean conceptuallyUnrooted)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface jebl.util.Attributable

`getAttribute, getAttributeMap, getAttributeNames, removeAttribute, setAttribute`

## Constructor Details

### CompactRootedTree

public CompactRootedTree(RootedTree t)
Do all the hard work.

Parameters:
  `t` -

## Method Details

### getChildren

public List<Node> getChildren(Node node)

Specified by:
  `getChildren` in interface `RootedTree`
Parameters:
  `node` - the node whose children are being requested.
Returns:
  the list of nodes that are the children of the given node. The set may be empty for a terminal node (a tip).

### getExternalNodeCount

public int getExternalNodeCount(Node node)

Specified by:
  `getExternalNodeCount` in interface `RootedTree`

### getExternalNodes

public List<Node> getExternalNodes(Node node)

Specified by:
  `getExternalNodes` in interface `RootedTree`
Parameters:
  `node` - the node whose external nodes are being requested.
Returns:
  the list of external nodes descendent of the given node. The set may be empty for a terminal node (a tip).

### hasHeights

public boolean hasHeights()

Specified by:
  `hasHeights` in interface `RootedTree`
Returns:
  Whether this tree has node heights available

### getHeight

public double getHeight(Node node)

Specified by:
  `getHeight` in interface `RootedTree`
Parameters:
  `node` - the node whose height is being requested.
Returns:
  the height of the given node. The height will be less than the parent's height and greater than it children's heights.

### hasLengths

public boolean hasLengths()

Specified by:
  `hasLengths` in interface `RootedTree`
Returns:
  Whether this tree has branch lengths available

### getLength

public double getLength(Node node)

Specified by:
  `getLength` in interface `RootedTree`
Parameters:
  `node` - the node whose branch length (to its parent) is being requested.
Returns:
  the length of the branch to the parent node (0.0 if the node is the root).

### isHeightsKnown

public boolean isHeightsKnown()

Specified by:
  `isHeightsKnown` in interface `RootedTree`
Returns:
  Whether the node heights are known or need to be recalculated from the lengths

### isLengthsKnown

public boolean isLengthsKnown()

Specified by:
  `isLengthsKnown` in interface `RootedTree`
Returns:
  Whether the branch lengths are known or need to be recalculated from the heights

### getParent

public Node getParent(Node node)

Specified by:
  `getParent` in interface `RootedTree`
Parameters:
  `node` - the node whose parent is requested
Returns:
  the parent node of the given node, or null if the node is the root node.

### getParentEdge

public Edge getParentEdge(Node node)

### getRootNode

public Node getRootNode()
Description copied from interface: `RootedTree`
The root of the tree has the largest node height of all nodes in the tree.

Specified by:
  `getRootNode` in interface `RootedTree`
Returns:
  the root of the tree.

### conceptuallyUnrooted

public boolean conceptuallyUnrooted()
Description copied from interface: `RootedTree`
Due to current implementation limitations, trees store "branch" information in nodes. So, internally rooted trees are genetrated when un-rooted would be more natural. This should be removed. If this is a rooted tree then it is rooted. This can really only confuse things. Trees are unrooted, RootedTrees are rooted. This is not an implementation limitation. It may be that a RootedTree has an arbitrary root but it is still rooted. With a rooted tree, it is convenient to store branch information at the node (i.e., for the branch above the node) because there is no "branch" object. Andrew. This function will probably become deprecated once the "development" tree viewer becomes in sync with the main tree viewer branch and some method of handling this concept has been introduced. Until then, this method remains.

Specified by:
  `conceptuallyUnrooted` in interface `RootedTree`
Returns:
  true if tree(s) are to be viewed as unrooted

### setConceptuallyUnrooted

public void setConceptuallyUnrooted(boolean conceptuallyUnrooted)

### isRoot

public boolean isRoot(Node node)

Specified by:
  `isRoot` in interface `RootedTree`
Parameters:
  `node` - the node
Returns:
  true if the node is the root of this tree.

### getExternalNodes

public Set<Node> getExternalNodes()

Specified by:
  `getExternalNodes` in interface `Tree`
Returns:
  a set of all nodes that have degree 1. These nodes are often refered to as 'tips'.

### getInternalNodes

public Set<Node> getInternalNodes()

Specified by:
  `getInternalNodes` in interface `Tree`
Returns:
  a set of all nodes that have degree 2 or more. These nodes are often refered to as internal nodes.

### getExternalEdges

public Set<Edge> getExternalEdges()

Specified by:
  `getExternalEdges` in interface `Tree`
Returns:
  a set of all edges that have a degree 1 node.

### getInternalEdges

public Set<Edge> getInternalEdges()

Specified by:
  `getInternalEdges` in interface `Tree`
Returns:
  a set of all edges for which both nodes have degree 2 or more.

### getTaxa

public Set<Taxon> getTaxa()

Specified by:
  `getTaxa` in interface `Tree`
Returns:
  the set of taxa associated with the external nodes of this tree. The size of this set should be the same as the size of the external nodes set.

### getTaxon

public Taxon getTaxon(Node node)

Specified by:
  `getTaxon` in interface `Tree`
Parameters:
  `node` - the node whose associated taxon is being requested.
Returns:
  the taxon object associated with the given node, or null if the node is an internal node.

### isExternal

public boolean isExternal(Node node)

Specified by:
  `isExternal` in interface `Tree`
Parameters:
  `node` - the node
Returns:
  true if the node is of degree 1.

### getNode

public Node getNode(Taxon taxon)

Specified by:
  `getNode` in interface `Tree`
Parameters:
  `taxon` - the taxon
Returns:
  the external node associated with the given taxon, or null if the taxon is not a member of the taxa set associated with this tree.

### renameTaxa

public void renameTaxa(Taxon from, Taxon to)

Specified by:
  `renameTaxa` in interface `Tree`

### getEdges

public List<Edge> getEdges(Node node)
Description copied from interface: `Graph`
Returns a list of edges connected to this node

Specified by:
  `getEdges` in interface `Graph`
Parameters:
  `node` -
Returns:
  the set of nodes that are attached by edges to the given node.

### getAdjacencies

public List<Node> getAdjacencies(Node node)
Description copied from interface: `Graph`
Returns a list of nodes connected to this node by an edge

Specified by:
  `getAdjacencies` in interface `Graph`
Parameters:
  `node` -
Returns:
  the set of nodes that are attached by edges to the given node.

### getEdge

public Edge getEdge(Node node1, Node node2) throws Graph.NoEdgeException
Description copied from interface: `Graph`
Returns the Edge that connects these two nodes

Specified by:
  `getEdge` in interface `Graph`
Parameters:
  `node1` -
  `node2` -
Returns:
  the edge object.
Throws:
  `Graph.NoEdgeException` - if the nodes are not directly connected by an edge.

### getEdgeLength

public double getEdgeLength(Node node1, Node node2) throws Graph.NoEdgeException
Description copied from interface: `Graph`
Returns the length of the edge that connects these two nodes

Specified by:
  `getEdgeLength` in interface `Graph`
Parameters:
  `node1` -
  `node2` -
Returns:
  the edge length.
Throws:
  `Graph.NoEdgeException` - if the nodes are not directly connected by an edge.

### getNodes

public Node[] getNodes(Edge edge)
Description copied from interface: `Graph`
Returns an array of 2 nodes which are the nodes at either end of the edge.

Specified by:
  `getNodes` in interface `Graph`
Parameters:
  `edge` -
Returns:
  an array of 2 edges

### getNodes

public Set<Node> getNodes()

Specified by:
  `getNodes` in interface `Graph`
Returns:
  the set of all nodes in this graph.

### getEdges

public Set<Edge> getEdges()

Specified by:
  `getEdges` in interface `Graph`
Returns:
  the set of all edges in this graph.

### getNodes

public Set<Node> getNodes(int degree)

Specified by:
  `getNodes` in interface `Graph`
Parameters:
  `degree` - the number of edges connected to a node
Returns:
  a set containing all nodes in this graph of the given degree.

### setAttribute

public void setAttribute(String name, Object value)
Description copied from interface: `Attributable`
Sets an named attribute for this object.

Specified by:
  `setAttribute` in interface `Attributable`
Parameters:
  `name` - the name of the attribute.
  `value` - the new value of the attribute.

### getAttribute

public Object getAttribute(String name)

Specified by:
  `getAttribute` in interface `Attributable`
Parameters:
  `name` - the name of the attribute of interest, or null if the attribute doesn't exist.
Returns:
  an object representing the named attributed for this object.

### removeAttribute

public void removeAttribute(String name)

Specified by:
  `removeAttribute` in interface `Attributable`
Parameters:
  `name` - name of attribute to remove

### getAttributeNames

public Set<String> getAttributeNames()

Specified by:
  `getAttributeNames` in interface `Attributable`
Returns:
  an array of the attributeNames that this object has.

### getAttributeMap

public Map<String,Object> getAttributeMap()
Description copied from interface: `Attributable`
Gets the entire attribute map.

Specified by:
  `getAttributeMap` in interface `Attributable`
Returns:
  an unmodifiable map